class Keyboard
  STOP_SEQ = {:x => 0, :y => 0, :ch => 0 }
  KEYS =
    {
     "q"   => [{:x => 6, :y => 6, :ch => 'q'.ord}, STOP_SEQ],
     "ESC" => [{:x => 1, :y => 1, :ch => "E".ord},
               {:x => 2, :y => 1, :ch => "S".ord},
               {:x => 3, :y => 1, :ch => "C".ord},
               STOP_SEQ],

     "F1"  => [{:x => 6, :y => 1, :ch => 'F'.ord},
               {:x => 7, :y => 1, :ch => '1'.ord},
               STOP_SEQ],
     "F2"  => [{:x => 9,  :y => 1, :ch => 'F'.ord},
               {:x => 10, :y => 1, :ch => '2'.ord},
               STOP_SEQ],
     "F3"  => [{:x => 12, :y => 1, :ch => 'F'.ord},
               {:x => 13, :y => 1, :ch => '3'.ord},
               STOP_SEQ],
     "F4"  => [{:x => 15, :y => 1, :ch => 'F'.ord},
               {:x => 16, :y => 1, :ch => '4'.ord},
               STOP_SEQ],
     "F5"  => [{:x => 19, :y => 1, :ch => 'F'.ord},
               {:x => 20, :y => 1, :ch => '5'.ord},
               STOP_SEQ],
     "F6"  => [{:x => 22, :y => 1, :ch => 'F'.ord},
               {:x => 23, :y => 1, :ch => '6'.ord},
               STOP_SEQ],
     "F7"  => [{:x => 25, :y => 1, :ch => 'F'.ord},
               {:x => 26, :y => 1, :ch => '6'.ord},
               STOP_SEQ],
     "F8"  => [{:x => 28, :y => 1, :ch => 'F'.ord},
               {:x => 29, :y => 1, :ch => '8'.ord},
               STOP_SEQ],
     "F9"  => [{:x => 33, :y => 1, :ch => 'F'.ord},
               {:x => 34, :y => 1, :ch => '9'.ord},
               STOP_SEQ],
     "F10" => [{:x => 36, :y => 1, :ch => 'F'.ord},
               {:x => 37, :y => 1, :ch => '1'.ord},
               {:x => 38, :y => 1, :ch => '0'.ord},
               STOP_SEQ],
     "F11" => [{:x => 40, :y => 1, :ch => 'F'.ord},
               {:x => 41, :y => 1, :ch => '1'.ord},
               {:x => 42, :y => 1, :ch => '1'.ord},
               STOP_SEQ],
     "F12" => [{:x => 44, :y => 1, :ch => 'F'.ord},
               {:x => 45, :y => 1, :ch => '1'.ord},
               {:x => 46, :y => 1, :ch => '2'.ord},
               STOP_SEQ],
     "PRN" => [{:x => 50, :y => 1, :ch => 'P'.ord},
               {:x => 51, :y => 1, :ch => 'R'.ord},
               {:x => 52, :y => 1, :ch => 'N'.ord},
               STOP_SEQ],
     "SCR" => [{:x => 54, :y => 1, :ch => 'S'.ord},
               {:x => 55, :y => 1, :ch => 'C'.ord},
               {:x => 56, :y => 1, :ch => 'R'.ord},
               STOP_SEQ],
     "BRK" => [{:x => 58, :y => 1, :ch => 'B'.ord},
               {:x => 59, :y => 1, :ch => 'R'.ord},
               {:x => 60, :y => 1, :ch => 'K'.ord},
               STOP_SEQ],
     "LED1" => [{:x => 66, :y => 1, :ch => '-'.ord},
               STOP_SEQ],
     "LED2" => [{:x => 70, :y => 1, :ch => '-'.ord},
               STOP_SEQ],
     "LED3" => [{:x => 74, :y => 1, :ch => '-'.ord},
               STOP_SEQ],
     "BACKTICK" => [{:x => 1, :y => 4, :ch => '`'.ord},
               STOP_SEQ],
     "TILDE" => [{:x => 1, :y => 4, :ch => '~'.ord},
               STOP_SEQ],
     "1" => [{:x => 4, :y => 4, :ch => '1'.ord},
               STOP_SEQ],
     "!" => [{:x => 4, :y => 4, :ch => '!'.ord},
               STOP_SEQ],
     "2" => [{:x => 7, :y => 4, :ch => '2'.ord},
               STOP_SEQ],
     "@" => [{:x => 7, :y => 4, :ch => '@'.ord},
               STOP_SEQ],
     "3" => [{:x => 10, :y => 4, :ch => '3'.ord},
               STOP_SEQ],
     "#" => [{:x => 10, :y => 4, :ch => '#'.ord},
               STOP_SEQ],
     "4" => [{:x => 13, :y => 4, :ch => '4'.ord},
               STOP_SEQ],
     "$" => [{:x => 13, :y => 4, :ch => '$'.ord},
               STOP_SEQ],
     "5" => [{:x => 16, :y => 4, :ch => '5'.ord},
               STOP_SEQ],
     "%" => [{:x => 16, :y => 4, :ch => '%'.ord},
               STOP_SEQ],
     "6" => [{:x => 19, :y => 4, :ch => '6'.ord},
               STOP_SEQ],
     "^" => [{:x => 19, :y => 4, :ch => '^'.ord},
               STOP_SEQ],
     "7" => [{:x => 22, :y => 4, :ch => '7'.ord},
               STOP_SEQ],
     "&" => [{:x => 22, :y => 4, :ch => '&'.ord},
               STOP_SEQ],
     "8" => [{:x => 25, :y => 4, :ch => '8'.ord},
               STOP_SEQ],
     "*" => [{:x => 25, :y => 4, :ch => '*'.ord},
               STOP_SEQ],
     "9" => [{:x => 28, :y => 4, :ch => '9'.ord},
               STOP_SEQ],
     "(" => [{:x => 28, :y => 4, :ch => '('.ord},
               STOP_SEQ],
     "0" => [{:x => 31, :y => 4, :ch => '0'.ord},
               STOP_SEQ],
     ")" => [{:x => 31, :y => 4, :ch => ')'.ord},
               STOP_SEQ],
     "-" => [{:x => 34, :y => 4, :ch => '-'.ord},
               STOP_SEQ],
     "_" => [{:x => 34, :y => 4, :ch => '_'.ord},
               STOP_SEQ],
     "=" => [{:x => 37, :y => 4, :ch => '='.ord},
               STOP_SEQ],
     "+" => [{:x => 37, :y => 4, :ch => '+'.ord},
               STOP_SEQ],
     "\\" => [{:x => 40, :y => 4, :ch => "\\".ord},
               STOP_SEQ],
     "|" => [{:x => 40, :y => 4, :ch => "|".ord},
               STOP_SEQ],
     "BACKSPACE" => [{:x => 44, :y => 4, :ch => 0x2190},
                     {:x => 45, :y => 4, :ch => 0x2500},
                     {:x => 46, :y => 4, :ch => 0x2500},
               STOP_SEQ],
     "INS"  => [{:x => 50, :y => 4, :ch => 'I'.ord},
                {:x => 51, :y => 4, :ch => 'N'.ord},
                {:x => 52, :y => 4, :ch => 'S'.ord},
               STOP_SEQ],
     "HOM"  => [{:x => 54, :y => 4, :ch => 'H'.ord},
                {:x => 55, :y => 4, :ch => 'O'.ord},
                {:x => 56, :y => 4, :ch => 'M'.ord},
               STOP_SEQ],
     "PGU"  => [{:x => 58, :y => 4, :ch => 'P'.ord},
                {:x => 59, :y => 4, :ch => 'G'.ord},
                {:x => 60, :y => 4, :ch => 'U'.ord},
               STOP_SEQ],
     "NUMLOCK" => [{:x => 65, :y => 4, :ch => 'N'.ord},
               STOP_SEQ],
     "K_SLASH" => [{:x => 68, :y => 4, :ch => '/'.ord},
               STOP_SEQ],
     "K_STAR" => [{:x => 71, :y => 4, :ch => '*'.ord},
               STOP_SEQ],
     "K_MINUS" => [{:x => 74, :y => 4, :ch => '-'.ord},
               STOP_SEQ],
     "TAB"  => [{:x => 1, :y => 6, :ch => 'T'.ord},
                {:x => 2, :y => 6, :ch => 'A'.ord},
                {:x => 3, :y => 6, :ch => 'B'.ord},
               STOP_SEQ],
     "q" => [{:x => 6, :y => 6, :ch => 'q'.ord},
               STOP_SEQ],
     "Q" => [{:x => 6, :y => 6, :ch => 'Q'.ord},
               STOP_SEQ],
     "w" => [{:x => 9, :y => 6, :ch => 'w'.ord},
               STOP_SEQ],
     "W" => [{:x => 9, :y => 6, :ch => 'W'.ord},
               STOP_SEQ],
     "e" => [{:x => 12, :y => 6, :ch => 'e'.ord},
               STOP_SEQ],
     "E" => [{:x => 12, :y => 6, :ch => 'E'.ord},
               STOP_SEQ],
     "r" => [{:x => 15, :y => 6, :ch => 'r'.ord},
               STOP_SEQ],
     "R" => [{:x => 15, :y => 6, :ch => 'R'.ord},
               STOP_SEQ],
     "t" => [{:x => 18, :y => 6, :ch => 't'.ord},
               STOP_SEQ],
     "T" => [{:x => 18, :y => 6, :ch => 'T'.ord},
               STOP_SEQ],
     "y" => [{:x => 21, :y => 6, :ch => 'y'.ord},
               STOP_SEQ],
     "Y" => [{:x => 21, :y => 6, :ch => 'Y'.ord},
               STOP_SEQ],
     "u" => [{:x => 24, :y => 6, :ch => 'u'.ord},
               STOP_SEQ],
     "U" => [{:x => 24, :y => 6, :ch => 'U'.ord},
               STOP_SEQ],
     "i" => [{:x => 27, :y => 6, :ch => 'i'.ord},
               STOP_SEQ],
     "I" => [{:x => 27, :y => 6, :ch => 'I'.ord},
               STOP_SEQ],
     "o" => [{:x => 30, :y => 6, :ch => 'o'.ord},
               STOP_SEQ],
     "O" => [{:x => 30, :y => 6, :ch => 'O'.ord},
               STOP_SEQ],
     "p" => [{:x => 33, :y => 6, :ch => 'p'.ord},
               STOP_SEQ],
     "P" => [{:x => 33, :y => 6, :ch => 'P'.ord},
               STOP_SEQ],
     "[" => [{:x => 36, :y => 6, :ch => '['.ord},
               STOP_SEQ],
     "{" => [{:x => 36, :y => 6, :ch => '{'.ord},
               STOP_SEQ],
     "]" => [{:x => 39, :y => 6, :ch => ']'.ord},
               STOP_SEQ],
     "}" => [{:x => 39, :y => 6, :ch => '}'.ord},
               STOP_SEQ],
     "ENTER" => [{:x => 43, :y => 6, :ch => 0x2591},
                 {:x => 43, :y => 7, :ch => 0x2591},
                 {:x => 41, :y => 8, :ch => 0x2591},
                 {:x => 45, :y => 8, :ch => 0x2591},

                 {:x => 44, :y => 6, :ch => 0x2591},
                 {:x => 44, :y => 7, :ch => 0x2591},
                 {:x => 42, :y => 8, :ch => 0x2591},
                 {:x => 46, :y => 8, :ch => 0x2591},

                 {:x => 46, :y => 6, :ch => 0x2591},
                 {:x => 46, :y => 7, :ch => 0x2591},
                 {:x => 44, :y => 8, :ch => 0x2591},

                 {:x => 46, :y => 8, :ch => 0x2591},
               STOP_SEQ],
    "DEL" => [{:x => 50, :y => 6, :ch => 'D'.ord},
              {:x => 51, :y => 6, :ch => 'E'.ord},
              {:x => 52, :y => 6, :ch => 'L'.ord},
               STOP_SEQ],
    "END" => [{:x => 54, :y => 6, :ch => 'E'.ord},
              {:x => 55, :y => 6, :ch => 'N'.ord},
              {:x => 56, :y => 6, :ch => 'D'.ord},
               STOP_SEQ],
    "PGD" => [{:x => 50, :y => 6, :ch => 'P'.ord},
              {:x => 51, :y => 6, :ch => 'G'.ord},
              {:x => 52, :y => 6, :ch => 'D'.ord},
               STOP_SEQ],
    "K_7" => [{:x => 65, :y => 6, :ch => '7'.ord},
               STOP_SEQ],
    "K_8" => [{:x => 68, :y => 6, :ch => '8'.ord},
               STOP_SEQ],
    "K_9" => [{:x => 71, :y => 6, :ch => '9'.ord},
               STOP_SEQ],
    "K_PLUS" => [{:x => 74, :y => 6, :ch => ' '.ord},
                 {:x => 75, :y => 7, :ch => '+'.ord},
                 {:x => 76, :y => 8, :ch => ' '.ord},
               STOP_SEQ],
    "K_CAPS" => [{:x => 1, :y => 8, :ch => 'C'.ord},
                 {:x => 2, :y => 8, :ch => 'A'.ord},
                 {:x => 3, :y => 8, :ch => 'P'.ord},
                 {:x => 4, :y => 8, :ch => 'S'.ord},
               STOP_SEQ],
    "a" => [{:x => 7, :y => 8, :ch => 'a'.ord},
               STOP_SEQ],
    "A" => [{:x => 7, :y => 8, :ch => 'A'.ord},
               STOP_SEQ],
    "s" => [{:x => 10, :y => 8, :ch => 's'.ord},
               STOP_SEQ],
    "S" => [{:x => 10, :y => 8, :ch => 'S'.ord},
               STOP_SEQ],
    "d" => [{:x => 13, :y => 8, :ch => 'd'.ord},
               STOP_SEQ],
    "D" => [{:x => 13, :y => 8, :ch => 'D'.ord},
               STOP_SEQ],
    "f" => [{:x => 16, :y => 8, :ch => 'f'.ord},
               STOP_SEQ],
    "F" => [{:x => 16, :y => 8, :ch => 'F'.ord},
               STOP_SEQ],
    "g" => [{:x => 19, :y => 8, :ch => 'g'.ord},
               STOP_SEQ],
    "G" => [{:x => 19, :y => 8, :ch => 'G'.ord},
               STOP_SEQ],
    "h" => [{:x => 22, :y => 8, :ch => 'h'.ord},
               STOP_SEQ],
    "H" => [{:x => 22, :y => 8, :ch => 'H'.ord},
               STOP_SEQ],
    "j" => [{:x => 25, :y => 8, :ch => 'j'.ord},
               STOP_SEQ],
    "J" => [{:x => 25, :y => 8, :ch => 'J'.ord},
               STOP_SEQ],
    "k" => [{:x => 28, :y => 8, :ch => 'k'.ord},
               STOP_SEQ],
    "K" => [{:x => 28, :y => 8, :ch => 'K'.ord},
               STOP_SEQ],
    "l" => [{:x => 31, :y => 8, :ch => 'l'.ord},
               STOP_SEQ],
    "L" => [{:x => 31, :y => 8, :ch => 'L'.ord},
               STOP_SEQ],
    ";" => [{:x => 34, :y => 8, :ch => ';'.ord},
               STOP_SEQ],
    ":" => [{:x => 34, :y => 8, :ch => ':'.ord},
               STOP_SEQ],
    "'" => [{:x => 37, :y => 8, :ch => "'".ord},
               STOP_SEQ],
    "\"" => [{:x => 37, :y => 8, :ch => "\"".ord},
               STOP_SEQ],
    "K_4" => [{:x => 65, :y => 8, :ch => "4".ord},
               STOP_SEQ],
    "K_5" => [{:x => 68, :y => 8, :ch => "5".ord},
               STOP_SEQ],
    "K_6" => [{:x => 71, :y => 8, :ch => "6".ord},
               STOP_SEQ],
    "L_SHIFT" => [{:x => 1, :y => 10, :ch => "S".ord},
                  {:x => 2, :y => 10, :ch => "H".ord},
                  {:x => 3, :y => 10, :ch => "I".ord},
                  {:x => 4, :y => 10, :ch => "F".ord},
                  {:x => 5, :y => 10, :ch => "T".ord},
               STOP_SEQ],
    "z" => [{:x => 9 , :y => 10, :ch => "z".ord},
               STOP_SEQ],
    "Z" => [{:x => 9 , :y => 10, :ch => "Z".ord},
               STOP_SEQ],
    "x" => [{:x => 12 , :y => 10, :ch => "x".ord},
               STOP_SEQ],
    "X" => [{:x => 12 , :y => 10, :ch => "X".ord},
               STOP_SEQ],
    "c" => [{:x => 15 , :y => 10, :ch => "c".ord},
               STOP_SEQ],
    "C" => [{:x => 15 , :y => 10, :ch => "C".ord},
               STOP_SEQ],
    "v" => [{:x => 18 , :y => 10, :ch => "v".ord},
               STOP_SEQ],
    "V" => [{:x => 18 , :y => 10, :ch => "V".ord},
               STOP_SEQ],
    "b" => [{:x => 21 , :y => 10, :ch => "b".ord},
               STOP_SEQ],
    "B" => [{:x => 21 , :y => 10, :ch => "B".ord},
               STOP_SEQ],
    "n" => [{:x => 24 , :y => 10, :ch => "n".ord},
               STOP_SEQ],
    "N" => [{:x => 24 , :y => 10, :ch => "N".ord},
               STOP_SEQ],
    "m" => [{:x => 27 , :y => 10, :ch => "m".ord},
               STOP_SEQ],
    "M" => [{:x => 27 , :y => 10, :ch => "M".ord},
               STOP_SEQ],
    "," => [{:x => 30 , :y => 10, :ch => ",".ord},
               STOP_SEQ],
    "<" => [{:x => 30 , :y => 10, :ch => "<".ord},
               STOP_SEQ],
    "." => [{:x => 33 , :y => 10, :ch => ".".ord},
               STOP_SEQ],
    ">" => [{:x => 33 , :y => 10, :ch => ">".ord},
               STOP_SEQ],
    "/" => [{:x => 36 , :y => 10, :ch => "/".ord},
               STOP_SEQ],
    "?" => [{:x => 36 , :y => 10, :ch => "?".ord},
               STOP_SEQ],
    "R_SHIFT" => [{:x => 42, :y => 10, :ch => "S".ord},
                  {:x => 43, :y => 10, :ch => "H".ord},
                  {:x => 44, :y => 10, :ch => "I".ord},
                  {:x => 45, :y => 10, :ch => "F".ord},
                  {:x => 46, :y => 10, :ch => "T".ord},
               STOP_SEQ],
    "ARROW_UP" => [{:x => 54 , :y => 10, :ch => "(".ord},
                   {:x => 55 , :y => 10, :ch => 0x2191},
                   {:x => 56 , :y => 10, :ch => ")".ord},
               STOP_SEQ],
    "K_1" => [{:x => 65 , :y => 10, :ch => "1".ord},
               STOP_SEQ],
    "K_2" => [{:x => 68 , :y => 10, :ch => "2".ord},
               STOP_SEQ],
    "K_3" => [{:x => 71 , :y => 10, :ch => "3".ord},
               STOP_SEQ],
    "K_ENTER" => [{:x => 74, :y => 10, :ch => 0x2591},
                  {:x => 74, :y => 11, :ch => 0x2591},
                  {:x => 74, :y => 12, :ch => 0x2591},
               STOP_SEQ],
    "L_CTRL" => [ {:x => 1, :y => 12, :ch => "C".ord},
                  {:x => 2, :y => 12, :ch => "T".ord},
                  {:x => 3, :y => 12, :ch => "R".ord},
                  {:x => 4, :y => 12, :ch => "L".ord},
               STOP_SEQ],
    "L_MOD4" => [ {:x => 6, :y => 12, :ch => "W".ord},
                  {:x => 7, :y => 12, :ch => "I".ord},
                  {:x => 8, :y => 12, :ch => "N".ord},
               STOP_SEQ],
    "L_ALT" => [  {:x => 10, :y => 12, :ch => "A".ord},
                  {:x => 11, :y => 12, :ch => "L".ord},
                  {:x => 12, :y => 12, :ch => "T".ord},
               STOP_SEQ],
    "SPACE" => [  {:x => 14, :y => 12, :ch => " ".ord},
                  {:x => 15, :y => 12, :ch => " ".ord},
                  {:x => 16, :y => 12, :ch => " ".ord},
                  {:x => 17, :y => 12, :ch => " ".ord},
                  {:x => 18, :y => 12, :ch => " ".ord},

                  {:x => 19, :y => 12, :ch => "S".ord},
                  {:x => 20, :y => 12, :ch => "P".ord},
                  {:x => 21, :y => 12, :ch => "A".ord},
                  {:x => 22, :y => 12, :ch => "C".ord},
                  {:x => 23, :y => 12, :ch => "E".ord},

                  {:x => 24, :y => 12, :ch => " ".ord},
                  {:x => 25, :y => 12, :ch => " ".ord},
                  {:x => 26, :y => 12, :ch => " ".ord},
                  {:x => 27, :y => 12, :ch => " ".ord},
                  {:x => 28, :y => 12, :ch => " ".ord},
               STOP_SEQ],
    "R_ALT" => [ {:x => 30, :y => 12, :ch => "A".ord},
                 {:x => 31, :y => 12, :ch => "L".ord},
                 {:x => 32, :y => 12, :ch => "T".ord},
               STOP_SEQ],
    "R_MOD4" => [ {:x => 34, :y => 12, :ch => "W".ord},
                  {:x => 35, :y => 12, :ch => "I".ord},
                  {:x => 36, :y => 12, :ch => "N".ord},
               STOP_SEQ],
    "R_PROP" => [ {:x => 38, :y => 12, :ch => "P".ord},
                  {:x => 39, :y => 12, :ch => "R".ord},
                  {:x => 40, :y => 12, :ch => "P".ord},
               STOP_SEQ],
    "R_CTRL" => [ {:x => 43, :y => 12, :ch => "C".ord},
                  {:x => 44, :y => 12, :ch => "T".ord},
                  {:x => 45, :y => 12, :ch => "R".ord},
                  {:x => 46, :y => 12, :ch => "L".ord},
               STOP_SEQ],
    "ARROW_LEFT" => [{:x => 50 , :y => 12, :ch => "(".ord},
                     {:x => 51 , :y => 12, :ch => 0x2190},
                     {:x => 52 , :y => 12, :ch => ")".ord},
               STOP_SEQ],
    "ARROW_DOWN" => [{:x => 50, :y => 12, :ch => "(".ord},
                     {:x => 51, :y => 12, :ch => 0x2193},
                     {:x => 52, :y => 12, :ch => ")".ord},
               STOP_SEQ],
    "ARROW_RIGHT" => [{:x => 58, :y => 12, :ch => "(".ord},
                      {:x => 59, :y => 12, :ch => 0x2192},
                      {:x => 60, :y => 12, :ch => ")".ord},
               STOP_SEQ],
    "K_0" => [{:x => 65, :y => 12, :ch => " ".ord},
              {:x => 66, :y => 12, :ch => "0".ord},
              {:x => 67, :y => 12, :ch => " ".ord},
              {:x => 68, :y => 12, :ch => " ".ord},
              STOP_SEQ],
    "K_PERIOD" => [{:x => 71, :y => 12, :ch => " ".ord},
                   STOP_SEQ]
    }
end
